unit test_voltage1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, Grids,
  StdCtrls, TAGraph, TASeries, TATransformations;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnNeu: TButton;
    btnClose: TButton;
    Chart1: TChart;
    Chart1LineSeries2: TLineSeries;
    Memo1: TMemo;

    procedure Berechnen;
    procedure btnCloseClick(Sender: TObject);
    procedure btnNeuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

const
  lipomax=4.2;                                     {normale LiPo Zellen haben 4,2V}
  appname='Test Chart';

  ccolor1=clRed;                {nur dass man sieht wenn sich etwas ändert}
  ccolor2=clGreen;

{The relationship of voltage and capacity from RC-Groups:
 https://blog.ampow.com/lipo-voltage-chart/
 https://www.rcgroups.com/forums/showpost.php?p=29431951
 https://www.flitetest.com/articles/Parallel_Charging_Your_LiPo_Batteries}

{ Verlauf für eine Zelle }
s1tab: array [0..20] of double = (
  4.20, 4.15, 4.11, 4.08, 4.02, 3.98, 3.95, 3.91, 3.87, 3.85, 3.84,
  3.82, 3.80, 3.79, 3.77, 3.75, 3.73, 3.71, 3.69, 3.61, 3.27);

{ Verlauf für Akku mit 4 Zellen}
s4tab: array [0..20] of double = (
  16.8, 16.6,  16.45, 16.33, 16.09, 15.93, 15.81, 15.66, 15.5, 15.42, 15.34,
  15.26, 15.18, 15.14, 15.06, 14.99, 14.91, 14.83, 14.75, 14.43, 13.09);

{ Restkapazität für Spannungsverlauf oben}
CapTab: array [0..20] of double = (
  100,  95,   90,   85,   80,   75,   70,   65,   60,   55,   50,
  45,   40,   35,   30,   25,   20,   15,   10,   5,    0);


implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);      {Allerlei Vorbereitungsarbeiten}
begin
  DefaultFormatSettings.DecimalSeparator:='.';
  Caption:=appname;
  Memo1.Lines.Clear;
  Chart1LineSeries2.SeriesColor:=ccolor1;
//  Berechnen;
end;

procedure TForm1.Berechnen;                        {Anzeige der Kurve}
var i: integer;
    p1, v: double;

begin
  try
    Chart1LineSeries2.Clear;                       {Chart erstmal löschen}
  except
    on e: Exception do begin
      Memo1.Lines.Add(E.Message);                  {Fehleranzeige im Memofeld,
                                           kann man wahrscheinlich verbessern}
    end;
  end;

  for i:=0 to 20 do begin                          {Restkapazität anzeigen}
    Chart1LineSeries2.AddXY(captab[i], s4tab[i]);
  end;
end;

procedure TForm1.btnCloseClick(Sender: TObject);    {Programm beenden}
begin
  Close;
end;

procedure TForm1.btnNeuClick(Sender: TObject);
begin
  if Chart1LineSeries2.SeriesColor=ccolor1 then     {Farbe änert sich bei Neuzeichnen}
    Chart1LineSeries2.SeriesColor:=ccolor2
  else
    Chart1LineSeries2.SeriesColor:=ccolor1;
  Berechnen;
end;

end.

